using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace CrosswordMatchmaker
{
    class Program
    {

        static StreamReader sr;
        static List<string> dic;

        static void Main(string[] args) {
            //The StreamReader that reads in words.
            sr = new StreamReader("cedt.dic");

            //The name-value pairs of sorted strings and actual strings
            dic = new List<string>();

            string s = "";

            //Build the Dictionary.
            Console.Write("Loading Dictionary...");
            while ((s = getWord()) != null) {
                dic.Add(s);
            }
            Console.WriteLine("\rDictionary Loaded.      ");
            Console.WriteLine("Type in combo. \r\nType in exit to quit.");

            string ins = "";
            Console.Write("> ");
            while ((ins = Console.ReadLine()) != "exit") {
                
                //loop the loop and print
                foreach (string  var in dic) {

                    if(ins.Length == var.Length){
                        if(isMatch(ins, var))
                            Console.WriteLine("\t"+var);
                    }

                }
                Console.Write("> ");
            }



        }

        private static bool isMatch(string ins, string var) {
            for (int i = 0; i < ins.Length; i++) {
                if (ins[i] == ' ' || ins[i] == '*')
                    continue;
                if (var[i] != ins[i])
                    return false;
            }
            return true;
        }


        /// <summary>
        ///	From a text-file, read one space delimited word and return it.
        /// </summary>
        /// <returns>The next word in the File</returns>
        private static string getWord() {
            int i = 0;
            char ch = ' ';
            string reply = "";
            while (true) {
                i = sr.Read();
                if (i == -1) return null;
                ch = (char)i;
                if (char.IsWhiteSpace(ch)) break;
                reply += ch;
            }
            //if("".Equals(reply)) return null;
            return reply;
        }

    }
}
